(function () {
  'use strict';

  ((Drupal, once) => {
    Drupal.mercuryEditorSyncFields = [];
    function applyChanges(event) {
      const element = event.target;
      const ref = element.getAttribute('data-sync-changes');
      const value = element.value || element.textContent;
      window.parent.Drupal.mercuryEditorSyncFields.filter(e => e.getAttribute('data-sync-changes') === ref).filter(e => e !== element).forEach((e) => {
        const prop = e.hasAttribute('value') ? 'value' : 'textContent';
        e[prop] = value;
      });
    }
    Drupal.behaviors.mercuryEditorSyncChanges = {
      attach: function attach(context, settings) {
        once('me-close-builder', '[data-sync-changes]').forEach((e) => {
          window.parent.Drupal.mercuryEditorSyncFields.push(e);
          e.addEventListener('input', applyChanges);
          e.addEventListener('change', applyChanges);
        });
      }
    };
  })(Drupal, once);

})();
