<?php

namespace Drupal\mercury_editor_iframe\Ajax;

use Drupal\Core\Ajax\RedirectCommand;
use Drupal\Core\Asset\AttachedAssets;
use Drupal\Core\Ajax\CommandWithAttachedAssetsInterface;

/**
 * Ajax command to close an iFrame dialog.
 */
class RedirectParentCommand extends RedirectCommand implements CommandWithAttachedAssetsInterface {

  /**
   * {@inheritDoc}
   */
  public function render() {
    return ['command' => 'redirectParent'] + parent::render();
  }

  /**
   * {@inheritDoc}
   */
  public function getAttachedAssets() {
    $assets = new AttachedAssets();
    $assets->setLibraries(['mercury_editor_iframe/redirect_parent']);
    return $assets;
  }
}
