<?php

namespace Drupal\mercury_editor_iframe\Ajax;

use Drupal\Core\Url;
use Drupal\Core\Ajax\CommandInterface;
use Drupal\layout_paragraphs\Utility\Dialog;

/**
 * Ajax command to request a layout via Ajax.
 */
class RefreshLayoutCommand implements CommandInterface {

  /**
   * The layout object.
   *
   * @var \Drupal\layout_paragraphs\LayoutParagraphsLayout
   */
  protected $layout;

  /**
   * Constructor.
   */
  public function __construct($layout) {
    $this->layout = $layout;
  }

  /**
   * Render custom ajax command.
   *
   * @return array
   *   The command array.
   */
  public function render() {
    $url = Url::fromRoute('mercury_editor_iframe.refresh_layout', [
      'layout_paragraphs_layout' => $this->layout->id(),
    ])->toString();
    $dialogId = Dialog::dialogSelector($this->layout);
    return [
      'command' => 'mercuryEditorIframeRefreshLayout',
      'url' => $url,
      'dialogId' => $dialogId,
    ];
  }

}
