<?php

namespace Drupal\mercury_editor_iframe\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Alters layout paragraphs builder edit and insert routes.
 *
 * Since the goal of this module is to render layout paragraphs component edit
 * and insert forms using the admin theme, this route subscriber simply sets
 * the _adming_route setting to true.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    // Change path '/user/login' to '/login'.
    if ($route = $collection->get('layout_paragraphs.builder.edit_item')) {
      $route->setOption('_admin_route', TRUE);
    }
    if ($route = $collection->get('layout_paragraphs.builder.insert')) {
      $route->setOption('_admin_route', TRUE);
    }
    if ($route = $collection->get('layout_paragraphs.builder.choose_component')) {
      $route->setOption('_admin_route', TRUE);
    }
  }

}
