(($, Drupal, once) => {

  function open(dropBtnMenu) {
    dropBtnMenu.classList.add('open');
    dropBtnMenu.querySelector('.me-dropbtn__toggle').classList.add('active');
    dropBtnMenu.querySelector('.me-dropbtn__btn-list').classList.remove('visually-hidden');
  }

  function close(dropBtnMenu) {
    dropBtnMenu.classList.remove('open');
    dropBtnMenu.querySelector('.me-dropbtn__toggle').classList.remove('active');
    dropBtnMenu.querySelector('.me-dropbtn__btn-list').classList.add('visually-hidden');
  }

  function isOpen(dropBtnMenu) {
    return dropBtnMenu.classList.contains('open');
  }

  Drupal.behaviors.mercuryEditorEditTrayDropBtn = {
    attach: function(context, settings) {
      once('me-dropbtn', '.me-dropbtn', context).forEach((dropBtnMenu) => {
        const toggleElement = dropBtnMenu.querySelector('.me-dropbtn__toggle');
        toggleElement.addEventListener('click', (e) => {
          if (isOpen(dropBtnMenu)) {
            close(dropBtnMenu);
          }
          else {
            open(dropBtnMenu);
          }
        });
        const primaryBtn = dropBtnMenu.querySelector('.me-dropbtn__btn--primary');
        primaryBtn.addEventListener('focus', (e) => {
          open(dropBtnMenu);
        });
        const lastBtn = dropBtnMenu.querySelector('.me-dropbtn__btn:last-child a');
        document.addEventListener('focusout', (e) => {
          if (e.target.closest('.me-dropbtn')) {
            setTimeout(() => {
              if (!document.activeElement.closest('.me-dropbtn')) {
                close(dropBtnMenu);
              }
            }, 100);
          }
        });
      });
    }
  }
})(jQuery, Drupal, once)
